

.. _what_is_kubernetes:

================================
**What is Kubernetes ?**
================================

.. seealso::

   - https://kubernetes.io/docs/concepts/overview/what-is-kubernetes/
   - https://github.com/kubernetes/website/edit/master/content/en/docs/concepts/overview/what-is-kubernetes.md
   - https://www.openservicebrokerapi.org/



What is Kubernetes ?
========================

Kubernetes is a portable, extensible, open-source platform for managing
containerized workloads and services, that facilitates both declarative
configuration and automation.

It has a large, rapidly growing ecosystem.

Kubernetes services, support, and tools are widely available.

**The name Kubernetes originates from Greek, meaning helmsman (timonier en français)
or pilot**.

**Google open-sourced the Kubernetes project in 2014**.

Kubernetes combines over 15 years of Google’s experience running
production workloads at scale with best-of-breed ideas and practices
from the community


Why you need Kubernetes and what it can do
============================================

Containers are a good way to bundle and run your applications.

In a production environment, you need to manage the containers that run
the applications and ensure that there is no downtime.

For example, if a container goes down, another container needs to start.
Wouldn’t it be easier if this behavior was handled by a system ?
That’s how Kubernetes comes to the rescue!

Kubernetes provides you with a framework to run distributed systems
resiliently.
It takes care of scaling and failover for your application, provides
deployment patterns, and more. For example, Kubernetes can easily
manage a canary deployment for your system.

Kubernetes provides you with:

- **Service discovery and load balancing**
  Kubernetes can expose a container using the DNS name or using their
  own IP address. If traffic to a container is high, Kubernetes is able
  to load balance and distribute the network traffic so that the
  deployment is stable.
- **Storage orchestration**
  Kubernetes allows you to automatically mount a storage system of your
  choice, such as local storages, public cloud providers, and more.
- **Automated rollouts and rollbacks**
  You can describe the desired state for your deployed containers
  using Kubernetes, and it can change the actual state to the desired
  state at a controlled rate.
  For example, you can automate Kubernetes to create new containers for
  your deployment, remove existing containers and adopt all their
  resources to the new container.
- **Automatic bin packing**
  You provide Kubernetes with a cluster of nodes that it can use to run
  containerized tasks. You tell Kubernetes how much CPU and memory (RAM)
  each container needs.
  Kubernetes can fit containers onto your nodes to make the best use
  of your resources.
- **Self-healing** (auto-réparation en français)
  Kubernetes restarts containers that fail, replaces containers, kills
  containers that don’t respond to your user-defined health check, and
  doesn’t advertise them to clients until they are ready to serve.
- **Secret and configuration management**
  Kubernetes lets you store and manage sensitive information, such as
  passwords, OAuth tokens, and SSH keys.
  You can deploy and update secrets and application configuration without
  rebuilding your container images, and without exposing secrets in
  your stack configuration.

What Kubernetes is not
========================

.. seealso::

   - https://www.openservicebrokerapi.org/

Kubernetes is not a traditional, all-inclusive PaaS (Platform as a Service)
system.

Since Kubernetes operates at the container level rather than at the
hardware level, it provides some generally applicable features common
to PaaS offerings, such as deployment, scaling, load balancing, logging,
and monitoring.

However, Kubernetes is not monolithic, and these default solutions are
optional and pluggable.

Kubernetes provides the building blocks for building developer platforms,
but preserves user choice and flexibility where it is important.

Kubernetes:

- Does not limit the types of applications supported.
  Kubernetes aims to support an extremely diverse variety of workloads,
  including stateless, stateful, and data-processing workloads.
  If an application can run in a container, it should run great on Kubernetes.
- Does not deploy source code and does not build your application.
  Continuous Integration, Delivery, and Deployment (CI/CD) workflows are
  determined by organization cultures and preferences as well as technical
  requirements.
- Does not provide application-level services, such as middleware
  (for example, message buses), data-processing frameworks (for example, Spark),
  databases (for example, MySQL), caches, nor cluster storage systems
  (for example, Ceph) as built-in services.
  Such components can run on Kubernetes, and/or can be accessed by
  applications running on Kubernetes through portable mechanisms, such
  as the `Open Service Broker`_.
- Does not dictate logging, monitoring, or alerting solutions.
  It provides some integrations as proof of concept, and mechanisms to
  collect and export metrics.
- Does not provide nor mandate a configuration language/system
  (for example, Jsonnet_).
  It provides a declarative API that may be targeted by arbitrary forms
  of declarative specifications.
- Does not provide nor adopt any comprehensive machine configuration,
  maintenance, management, or self-healing systems.
- Additionally, **Kubernetes is not a mere orchestration system**.
  In fact, it eliminates the need for orchestration.

  The technical definition of orchestration is execution of a defined
  workflow: first do A, then B, then C.

  In contrast, Kubernetes comprises a set of independent, composable
  control processes that continuously drive the current state towards
  the provided desired state.

  It shouldn’t matter how you get from A to C.

  Centralized control is also not required. This results in a system
  that is easier to use and more powerful, robust, resilient, and extensible


.. _`Open Service Broker`:  https://www.openservicebrokerapi.org/
.. _Jsonnet: https://jsonnet.org/
